/* All Rights reserved */

#include <AppKit/AppKit.h>
#include "AppController.h"

@implementation AppController

NSSound *sound;
NSTimer *updateTimer;

- (void) showPrefPanel: (id)sender
{
  /* insert your code here */
}


- (void) open: (id)sender
{
  NSOpenPanel *panel;
  NSString *path;
  
  panel = [NSOpenPanel openPanel];
  [panel setAllowsMultipleSelection: NO];
  [panel runModalForTypes: [NSSound soundUnfilteredFileTypes]];
  
  path = [[panel filenames] objectAtIndex: 0];
  
  if (sound != nil)
    {
      [sound stop];
      RELEASE(sound);
    }
  sound = [[NSSound alloc] initWithContentsOfFile: path byReference: NO];
  if (!sound)
    {
      NSRunAlertPanel (@"Error", @"Could not open selected file", @"OK", nil, nil);
      return;
    }
  
  [sound setDelegate: self];
  [slider setMaxValue: [sound duration]];
  [[NSApp keyWindow] setTitle: [path lastPathComponent]];
  
  if (!updateTimer)
    {
      updateTimer = [NSTimer scheduledTimerWithTimeInterval: 0.2
                                                     target: self
                                                   selector: @selector(update)
                                                   userInfo: nil
                                                    repeats: YES];
    }
}


- (void) pause: (id)sender
{
  NSLog (@"Pause = %d", [sound pause]);
}


- (void) play: (id)sender
{
  NSLog (@"Play = %d", [sound play]);
}


- (void) stop: (id)sender
{
  NSLog (@"Stop = %d", [sound stop]);
}


- (void) newTime: (id)sender
{
  NSLog (@"New Time = %g", [sender doubleValue]);
  [sound setCurrentTime: [sender doubleValue]];
}


- (void) resume: (id)sender
{
  NSLog (@"Resume = %d", [sound resume]);
}

- (void) update
{
  [time setStringValue: [NSString stringWithFormat: @"%d:%02d / %d:%02d",
                          (int)[sound currentTime] / 60, (int)[sound currentTime] % 60,
                          (int)[sound duration] / 60, (int)[sound duration] % 60]];
  [slider setDoubleValue: [sound currentTime]];
}

- (void)sound: (NSSound *)aSound didFinishPlaying: (BOOL)finishedPlaying
{
  if (finishedPlaying == NO)
    {
      NSRunAlertPanel (@"Error", @"Playback ended with errors", @"OK", nil, nil);
      return;
    }
}

@end
